package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashMap;
import java.util.Map;
import org.eclipse.ui.WorkbenchEncoding;

public class OptionManager {
  File file;
  
  HashMap<String, HashMap<String, String>> optionList;
  
  public OptionManager(File file) {
    this.file = file;
    this.optionList = new HashMap<>();
  }
  
  public String getOption(String groupName, String key) {
    HashMap<String, String> group = this.optionList.get(groupName);
    if (group == null)
      return null; 
    String value = group.get(key);
    return value;
  }
  
  public void setOption(String groupName, String key, String value) {
    HashMap<String, String> group = null;
    if (this.optionList.containsKey(groupName)) {
      group = this.optionList.get(groupName);
    } else {
      group = new HashMap<>();
      this.optionList.put(groupName, group);
    } 
    group.put(key, value);
  }
  
  public synchronized void readFile() {
    HashMap<String, String> curGroup = null;
    FileInputStream stream = null;
    BufferedReader reader = null;
    try {
      stream = new FileInputStream(this.file);
      reader = new BufferedReader(new InputStreamReader(stream, WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      String line = null;
      while ((line = reader.readLine()) != null) {
        line = line.trim().replace("\t", "");
        if (line.startsWith("[") && line.endsWith("]")) {
          String groupName = line.substring(1, line.length() - 1);
          curGroup = new HashMap<>();
          this.optionList.put(groupName, curGroup);
        } 
        if (line.contains("=") && curGroup != null) {
          int sepIndex = line.indexOf("=");
          String key = line.substring(0, sepIndex);
          String value = line.substring(sepIndex + 1);
          curGroup.put(key, value);
        } 
      } 
    } catch (IOException iOException) {
    
    } finally {
      if (reader != null)
        try {
          reader.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
      if (stream != null)
        try {
          stream.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
    } 
  }
  
  public synchronized boolean writeFile() {
    BufferedWriter writer = null;
    FileOutputStream stream = null;
    try {
      if (!this.file.getParentFile().exists() && 
        !this.file.getParentFile().mkdirs())
        return false; 
      if (!this.file.exists() && 
        !this.file.createNewFile())
        return false; 
      stream = new FileOutputStream(this.file);
      writer = new BufferedWriter(new OutputStreamWriter(stream, WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      for (Map.Entry<String, HashMap<String, String>> entryGroup : this.optionList.entrySet()) {
        writer.write("[" + (String)entryGroup.getKey() + "]\r\n");
        for (Map.Entry<String, String> entryItem : (Iterable<Map.Entry<String, String>>)((HashMap)entryGroup.getValue()).entrySet())
          writer.write((String)entryItem.getKey() + "=" + (String)entryItem.getKey() + "\r\n"); 
        writer.write("\r\n");
      } 
    } catch (IOException e) {
      return false;
    } finally {
      if (writer != null)
        try {
          writer.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
      if (stream != null)
        try {
          stream.close();
        } catch (IOException e) {
          e.printStackTrace();
        }  
    } 
    return true;
  }
}
